WriteResponseHandler (apache-cassandra API)
Date: 2014-10-21

org.apache.cassandra.service

## Class WriteResponseHandler

- java.lang.Object
- - org.apache.cassandra.service.AbstractWriteResponseHandler
  - - org.apache.cassandra.service.WriteResponseHandler

- All Implemented Interfaces:
    IAsyncCallback
  Direct Known Subclasses:
    DatacenterWriteResponseHandler

      public class WriteResponseHandler
      extends AbstractWriteResponseHandler

  Handles blocking writes for ONE, ANY, TWO, THREE, QUORUM, and ALL consistency levels.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static org.slf4j.Logger` | `logger`
    `protected int` | `responses`

    - ### Fields inherited from class org.apache.cassandra.service.AbstractWriteResponseHandler

      `callback, consistencyLevel, keyspace, naturalEndpoints, pendingEndpoints, start`

    - ### Fields inherited from interface org.apache.cassandra.net.IAsyncCallback

      `isAlive`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WriteResponseHandler(java.util.Collection<java.net.InetAddress> writeEndpoints, java.util.Collection<java.net.InetAddress> pendingEndpoints, ConsistencyLevel consistencyLevel, Keyspace keyspace, java.lang.Runnable callback, WriteType writeType)`
    `WriteResponseHandler(java.net.InetAddress endpoint, WriteType writeType)`
    `WriteResponseHandler(java.net.InetAddress endpoint, WriteType writeType, java.lang.Runnable callback)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `ackCount()`
    `boolean` | `isLatencyForSnitch()`
    `void` | `response(MessageIn m)` null message means "response from local write"

    - ### Methods inherited from class org.apache.cassandra.service.AbstractWriteResponseHandler

      `assureSufficientLiveNodes, get, signal, totalBlockFor`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected static final org.slf4j.Logger logger

    - #### responses

          protected volatile int responses

  - ### Constructor Detail

    - #### WriteResponseHandler

          public WriteResponseHandler(java.util.Collection<java.net.InetAddress> writeEndpoints,
                              java.util.Collection<java.net.InetAddress> pendingEndpoints,
                              ConsistencyLevel consistencyLevel,
                              Keyspace keyspace,
                              java.lang.Runnable callback,
                              WriteType writeType)

    - #### WriteResponseHandler

          public WriteResponseHandler(java.net.InetAddress endpoint,
                              WriteType writeType,
                              java.lang.Runnable callback)

    - #### WriteResponseHandler

          public WriteResponseHandler(java.net.InetAddress endpoint,
                              WriteType writeType)

  - ### Method Detail

    - #### response

          public void response(MessageIn m)

      Description copied from class: `AbstractWriteResponseHandler`
      null message means "response from local write"
      Specified by:
        `response` in interface `IAsyncCallback`
      Specified by:
        `response` in class `AbstractWriteResponseHandler`
      Parameters:
        `m` - response received.

    - #### ackCount

          protected int ackCount()

      Specified by:
        `ackCount` in class `AbstractWriteResponseHandler`

    - #### isLatencyForSnitch

          public boolean isLatencyForSnitch()

      Returns:
        true if this callback is on the read path and its latency should be given as input to the dynamic snitch.

Copyright © 2014 The Apache Software Foundation